//+------------------------------------------------------------------+
//|                                                          Ind.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, "
#property link      "Jane"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
//----
input bool       UseCenterLineFilter=false;
input bool       UseRVIFilter=false;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert.wav";
input color  ArrowColorUp =clrBlue;
input color  ArrowColorDn =clrRed;

//----
int      account =3123632;
extern int       period =20;
extern double deviation =2.0;
extern double      step =0.02;
extern double   maximum =0.2;
extern int       indent =0;
//----
double ExtArrowBufferUp[];
double ExtArrowBufferDn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorShortName("Ind");
   IndicatorDigits(_Digits);
//----
   SetIndexBuffer(0,ExtArrowBufferUp);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1,ArrowColorDn);
   SetIndexArrow(0,234);
   SetIndexEmptyValue(0,0.0);
   SetIndexLabel(0,"Up");
   SetIndexBuffer(1,ExtArrowBufferDn);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1,ArrowColorUp);
   SetIndexArrow(1,233);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"Dn");
//----
   HideTestIndicators(true);
//----
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
 {
   //if(account>0)
   //   if(account!=AccountInfoInteger(ACCOUNT_LOGIN))
   //      return(0);
//----
   int limit=0;
//----
   if(prev_calculated==0)
      limit=rates_total-1;
//----
   if(prev_calculated>0)
      limit=rates_total-prev_calculated;
//----
   for(int i=limit;i>=0;i--)
     {
      double bb_up=iBands(_Symbol,_Period,period,deviation,0,PRICE_CLOSE,MODE_UPPER,i);
      double bb_lw=iBands(_Symbol,_Period,period,deviation,0,PRICE_CLOSE,MODE_LOWER,i);
      double sar_curr=iSAR(_Symbol,_Period,step,maximum,i);
      double sar_prev=iSAR(_Symbol,_Period,step,maximum,i+1);
      double ma_center_curr=iMA(_Symbol,_Period,period,0,MODE_SMA,PRICE_CLOSE,i);
      double ma_center_prev=iMA(_Symbol,_Period,period,0,MODE_SMA,PRICE_CLOSE,i+1);
      double rvi_main=iRVI(_Symbol,_Period,period*5,MODE_MAIN,i);
      double rvi_signal=iRVI(_Symbol,_Period,period*5,MODE_SIGNAL,i);
      
      
      //----
      if(sar_prev<bb_up)
         if(sar_curr>bb_up)
          if ((UseCenterLineFilter && ma_center_prev>ma_center_curr) || !UseCenterLineFilter)
          if ((UseRVIFilter && rvi_main<rvi_signal) || !UseRVIFilter)
           {
            ExtArrowBufferUp[i]=sar_curr+indent*_Point;
             if(limit==1)
               if(i==1)
                 {
            
                  }
            }
    }
    
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      
      //
      //
      //
      //
      //
      
      if (ExtArrowBufferUp[whichBar+1] == EMPTY_VALUE && ExtArrowBufferUp[whichBar] != EMPTY_VALUE) doAlert(whichBar,"BUY");
      if (ExtArrowBufferDn[whichBar+1] == EMPTY_VALUE && ExtArrowBufferDn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"SELL");
    }         
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(" ADX ", Symbol()," ",Period()," " ,doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " ADX "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}




                  